Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 508236 - Changed child ebuild causes endless parent rebuild until you manually rebuild the child
Summary: Changed child ebuild causes endless parent rebuild until you manually rebuild...
Status: RESOLVED FIXED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Dependencies (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords: InVCS
Depends on:
Blocks: 484436
  Show dependency tree
 
Reported: 2014-04-20 14:18 UTC by Thomas Deutschmann
Modified: 2014-08-04 02:13 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge debug log (emerge-debug.log.gz,244.31 KB, application/x-gzip)
2014-04-20 14:19 UTC, Thomas Deutschmann
Details
pkgdb diff (pkgdb.diff,8.29 KB, patch)
2014-04-20 14:22 UTC, Thomas Deutschmann
Details | Diff
Another emerge debug log showing the iptables problem (emerge-update-world-debug_before.log.gz,119.11 KB, application/x-gzip)
2014-04-22 21:12 UTC, Thomas Deutschmann
Details
New emerge debug log from portage with commit de71f70eac5 (emerge-with-patch-debug.log.gz,299.39 KB, application/x-gzip)
2014-04-26 20:43 UTC, Thomas Deutschmann
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Thomas Deutschmann gentoo-dev Security 2014-04-20 14:18:07 UTC
Hi,

not easy to describe: On my systems I noticed that portage always wanted to rebuild app-admin/rsyslog-7.4.10. After reading the emerge debug log (which I'll attach) I noticed that the problem seems to be caused by dev-libs/liblognorm-0.37. So I decided to rebuild liblognorm and this solved my problem: portage no longer wants to re-emerge rsyslog.

Howto reproduce:
1) Grab this ebuild for dev-libs/liblognorm:
https://github.com/Whissi/gentoo-overlay/blob/fdc2314dafa59be62427635edc97fa4e66263d30/dev-libs/liblognorm/liblognorm-0.3.7.ebuild

2) Install app-admin/rsyslog. You can use the version from my overlay, but you can also use the version available in the official tree, they are the same.

3) Now replace the dev-libs/liblognorm ebuild with this one: https://github.com/Whissi/gentoo-overlay/blob/master/dev-libs/liblognorm/liblognorm-0.3.7.ebuild

As you can see I only changed rdeps and removed a non-working USE flag...


...and now, when you run

  # emerge --ask --verbose --update --deep --with-bdeps=y --newuse world

portage always wants to rebuild app-admin/rsyslog.

As said, you can break the loop when you re-emerge dev-libs/liblognorm.

Reproducible: Always



Expected Results:  
I don't understand why portage wants to rebuild app-admin/rsyslog. From the emerge debug log it looks like that portage detected a changed liblognorm ebuild but then I don't understand why portage finally decided *not* to rebuild liblognorm but rsyslog.
Comment 1 Thomas Deutschmann gentoo-dev Security 2014-04-20 14:19:36 UTC
Created attachment 375376 [details]
emerge debug log
Comment 2 Thomas Deutschmann gentoo-dev Security 2014-04-20 14:22:27 UTC
Created attachment 375380 [details, diff]
pkgdb diff

diff -rupN liblognorm-0.3.7.old/ /var/db/pkg/dev-libs/liblognorm-0.3.7/


liblognorm-0.3.7.old: The state when portage always wants to rebuild app-admin/rsyslog.

/var/db/pkg/dev-libs/liblognorm-0.3.7/: The state after I manually re-emerged liblognorm.
Comment 3 Sebastian Luther (few) 2014-04-20 17:08:00 UTC
Please provide emerge --info.
Comment 4 Thomas Deutschmann gentoo-dev Security 2014-04-20 21:00:33 UTC
# emerge --info
Portage 2.2.10 (default/linux/amd64/13.0, gcc-4.8.2, glibc-2.19, 3.10.37-gentoo x86_64)
=================================================================
System uname: Linux-3.10.37-gentoo-x86_64-Intel-R-_Core-TM-_i7-2600_CPU_@_3.40GHz-with-gentoo-2.2
KiB Mem:    32653364 total,  31893640 free
KiB Swap:    2097148 total,   2097148 free
Timestamp of tree: Fri, 18 Apr 2014 12:45:01 +0000
ld GNU ld (GNU Binutils) 2.24
distcc 3.1 x86_64-pc-linux-gnu [disabled]
app-shells/bash:          4.2_p47
dev-lang/python:          2.7.6, 3.3.5, 3.4.0
dev-util/cmake:           2.8.12.2
dev-util/pkgconfig:       0.28-r1
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.12.4
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.69
sys-devel/automake:       1.14.1
sys-devel/binutils:       2.24-r2
sys-devel/gcc:            4.8.2
sys-devel/gcc-config:     1.8
sys-devel/libtool:        2.4.2
sys-devel/make:           4.0-r1
sys-kernel/linux-headers: 3.10 (virtual/os-headers)
sys-libs/glibc:           2.19
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.de.gentoo.org/gentoo-portage/
    priority: -1000

whissi-overlay
    location: /usr/overlays/whissi-overlay
    sync-type: git
    sync-uri: https://github.com/Whissi/gentoo-overlay.git
    masters: gentoo

ABI="amd64"
ABI_X86="64"
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
ACCEPT_PROPERTIES="*"
ACCEPT_RESTRICT="*"
ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci"
APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias"
ARCH="amd64"
AUTOCLEAN="yes"
BOOTSTRAP_USE="cxx unicode python_targets_python3_3 python_targets_python2_7 multilib"
CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author"
CAMERAS="ptp2"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=corei7-avx -mno-movbe -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-bmi2 -mno-tbm -mno-avx2 -mno-lzcnt -mno-hle -mno-rdrnd -mno-f16c -mno-fsgsbase -mno-rdseed -mno-prfchw -mno-adx -mxsave -mxsaveopt --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -mtune=corei7-avx"
CFLAGS_amd64="-m64"
CFLAGS_x32="-mx32"
CFLAGS_x86="-m32"
CHOST="x86_64-pc-linux-gnu"
CHOST_amd64="x86_64-pc-linux-gnu"
CHOST_x32="x86_64-pc-linux-gnux32"
CHOST_x86="i686-pc-linux-gnu"
CLEAN_DELAY="5"
COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog cpu cpufreq disk dns ethstat network nginx ntpd ping uptime rrdcached filecount"
COLLISION_IGNORE="/lib/modules/* *.py[co] *$py.class */dropin.cache"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -march=corei7-avx -mno-movbe -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-bmi2 -mno-tbm -mno-avx2 -mno-lzcnt -mno-hle -mno-rdrnd -mno-f16c -mno-fsgsbase -mno-rdseed -mno-prfchw -mno-adx -mxsave -mxsaveopt --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -mtune=corei7-avx"
DCCC_PATH="/usr/lib64/distcc/bin"
DEFAULT_ABI="amd64"
DISTCC_LOG=""
DISTCC_VERBOSE=""
DISTDIR="/usr/portage/distfiles"
EDITOR="/bin/nano"
ELIBC="glibc"
EMERGE_DEFAULT_OPTS="--quiet-build=n --verbose"
EMERGE_WARNING_DELAY="10"
EPREFIX=""
EROOT="/"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FETCHCOMMAND="wget -t 3 -T 60 --passive-ftp -O "${DISTDIR}/${FILE}" "${URI}""
FETCHCOMMAND_RSYNC="rsync -avP "${URI}" "${DISTDIR}/${FILE}""
FETCHCOMMAND_SFTP="bash -c "x=\${2#sftp://} ; host=\${x%%/*} ; port=\${host##*:} ; host=\${host%:*} ; [[ \${host} = \${port} ]] && port=22 ; eval \"declare -a ssh_opts=(\${3})\" ; exec sftp -P \${port} \"\${ssh_opts[@]}\" \"\${host}:/\${x#*/}\" \"\$1\"" sftp "${DISTDIR}/${FILE}" "${URI}" "${PORTAGE_SSH_OPTS}""
FETCHCOMMAND_SSH="bash -c "x=\${2#ssh://} ; host=\${x%%/*} ; port=\${host##*:} ; host=\${host%:*} ; [[ \${host} = \${port} ]] && port=22 ; exec rsync --rsh=\"ssh -p\${port} \${3}\" -avP \"\${host}:/\${x#*/}\" \"\$1\"" rsync "${DISTDIR}/${FILE}" "${URI}" "${PORTAGE_SSH_OPTS}""
FFLAGS="-O2 -pipe"
GCC_SPECS=""
GENTOO_MIRRORS="http://ftp.uni-erlangen.de/pub/mirrors/gentoo/ ftp://mirror.netcologne.de/gentoo/ ftp://ftp.halifax.rwth-aachen.de/gentoo/ http://ftp.uni-kl.de/pub/linux/gentoo/ http://distfiles.gentoo.org"
GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx"
GRUB_PLATFORMS=""
GUILE_LOAD_PATH="/usr/share/guile/1.8"
HISTFILESIZE="10000"
HISTSIZE="5000"
HISTTIMEFORMAT="[%F %T]: "
HOME="/root"
ICECC_VERSION="/var/lib/icecream/x86_64-4.7.3.tar.gz"
INFOPATH="/usr/share/info:/usr/share/gcc-data/x86_64-pc-linux-gnu/4.8.2/info:/usr/share/binutils-data/x86_64-pc-linux-gnu/2.24/info"
INPUT_DEVICES="keyboard mouse evdev"
IUSE_IMPLICIT="prefix"
KERNEL="linux"
LANG="en_US.UTF-8"
LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text"
LC_MESSAGES="C"
LC_NUMERIC="de_DE.UTF-8"
LC_PAPER="de_DE.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LDFLAGS_amd64="-m elf_x86_64"
LDFLAGS_x32="-m elf32_x86_64"
LDFLAGS_x86="-m elf_i386"
LESS="-R -M --shift 5"
LESSCOLOR="yes"
LESSCOLORIZER="pygmentize"
LESSOPEN="|lesspipe %s"
LIBDIR_amd64="lib64"
LIBDIR_amd64_fbsd="lib64"
LIBDIR_arm="lib"
LIBDIR_arm64="lib64"
LIBDIR_n32="lib32"
LIBDIR_n64="lib64"
LIBDIR_o32="lib"
LIBDIR_ppc="lib32"
LIBDIR_ppc64="lib64"
LIBDIR_s390="lib32"
LIBDIR_s390x="lib64"
LIBDIR_sparc32="lib32"
LIBDIR_sparc64="lib64"
LIBDIR_x32="libx32"
LIBDIR_x86="lib32"
LIBDIR_x86_fbsd="lib32"
LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer"
LINGUAS="en de"
LOGNAME="root"
LS_COLORS="rs=0:di=01;34:ln=01;36:mh=00:pi=40;33:so=01;35:do=01;35:bd=40;33;01:cd=40;33;01:or=01;05;37;41:mi=01;05;37;41:su=37;41:sg=30;43:ca=30;41:tw=30;42:ow=34;42:st=37;44:ex=01;32:*.tar=01;31:*.tgz=01;31:*.arc=01;31:*.arj=01;31:*.taz=01;31:*.lha=01;31:*.lz4=01;31:*.lzh=01;31:*.lzma=01;31:*.tlz=01;31:*.txz=01;31:*.tzo=01;31:*.t7z=01;31:*.zip=01;31:*.z=01;31:*.Z=01;31:*.dz=01;31:*.gz=01;31:*.lrz=01;31:*.lz=01;31:*.lzo=01;31:*.xz=01;31:*.bz2=01;31:*.bz=01;31:*.tbz=01;31:*.tbz2=01;31:*.tz=01;31:*.deb=01;31:*.rpm=01;31:*.jar=01;31:*.war=01;31:*.ear=01;31:*.sar=01;31:*.rar=01;31:*.alz=01;31:*.ace=01;31:*.zoo=01;31:*.cpio=01;31:*.7z=01;31:*.rz=01;31:*.cab=01;31:*.jpg=01;35:*.jpeg=01;35:*.gif=01;35:*.bmp=01;35:*.pbm=01;35:*.pgm=01;35:*.ppm=01;35:*.tga=01;35:*.xbm=01;35:*.xpm=01;35:*.tif=01;35:*.tiff=01;35:*.png=01;35:*.svg=01;35:*.svgz=01;35:*.mng=01;35:*.pcx=01;35:*.mov=01;35:*.mpg=01;35:*.mpeg=01;35:*.m2v=01;35:*.mkv=01;35:*.webm=01;35:*.ogm=01;35:*.mp4=01;35:*.m4v=01;35:*.mp4v=01;35:*.vob=01;35:*.qt=01;35:*.nuv=01;35:*.wmv=01;35:*.asf=01;35:*.rm=01;35:*.rmvb=01;35:*.flc=01;35:*.avi=01;35:*.fli=01;35:*.flv=01;35:*.gl=01;35:*.dl=01;35:*.xcf=01;35:*.xwd=01;35:*.yuv=01;35:*.cgm=01;35:*.emf=01;35:*.axv=01;35:*.anx=01;35:*.ogv=01;35:*.ogx=01;35:*.pdf=00;32:*.ps=00;32:*.txt=00;32:*.patch=00;32:*.diff=00;32:*.log=00;32:*.tex=00;32:*.doc=00;32:*.aac=00;36:*.au=00;36:*.flac=00;36:*.mid=00;36:*.midi=00;36:*.mka=00;36:*.mp3=00;36:*.mpc=00;36:*.ogg=00;36:*.ra=00;36:*.wav=00;36:*.axa=00;36:*.oga=00;36:*.spx=00;36:*.xspf=00;36:"
MAIL="/var/mail/root"
MAKEOPTS="--jobs 9 --load-average 7.95"
MANPATH="/usr/local/share/man:/usr/share/man:/usr/share/gcc-data/x86_64-pc-linux-gnu/4.8.2/man:/usr/share/binutils-data/x86_64-pc-linux-gnu/2.24/man"
MULTILIB_ABIS="amd64 x86"
MULTILIB_STRICT_DENY="64-bit.*shared object"
MULTILIB_STRICT_DIRS="/lib32 /lib /usr/lib32 /usr/lib /usr/kde/*/lib32 /usr/kde/*/lib /usr/qt/*/lib32 /usr/qt/*/lib /usr/X11R6/lib32 /usr/X11R6/lib"
MULTILIB_STRICT_EXEMPT="(perl5|gcc|gcc-lib|binutils|eclipse-3|debug|portage|udev|systemd|clang|python-exec)"
NETBEANS="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml"
NGINX_MODULES_HTTP="access auth_basic autoindex browser charset empty_gif fastcgi gzip limit_conn limit_req map referer rewrite"
OFFICE_IMPLEMENTATION="libreoffice"
OLDPWD="/var/db/pkg/dev-libs"
PAGER="/usr/bin/less"
PATH="/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt/bin:/usr/x86_64-pc-linux-gnu/gcc-bin/4.8.2"
PHP_TARGETS="php5-5"
PKGDIR="/usr/portage/packages"
PORTAGE_ARCHLIST="hppa-hpux x86-solaris ppc-macos ia64-linux arm-linux ppc-aix x64-solaris ia64-hpux sparc64-solaris amd64-linux sh arm64 ppc64-linux alpha x86-fbsd sparc-fbsd ppc-openbsd x86-linux ia64 m68k-mint x86-netbsd arm m68k x64-openbsd hppa x86-freebsd x86 sparc-solaris x64-freebsd ppc x86-macos ppc64 x86-cygwin x86-openbsd sparc64-freebsd amd64-fbsd s390 x64-macos x86-interix x86-winnt amd64 sparc mips"
PORTAGE_BIN_PATH="/usr/lib64/portage/bin"
PORTAGE_COMPRESS_EXCLUDE_SUFFIXES="css gif htm[l]? jp[e]?g js pdf png"
PORTAGE_CONFIGROOT="/"
PORTAGE_DEBUG="0"
PORTAGE_DEPCACHEDIR="/var/cache/edb/dep"
PORTAGE_ELOG_CLASSES="warn error info log qa"
PORTAGE_ELOG_MAILFROM="portage@localhost"
PORTAGE_ELOG_MAILSUBJECT="[portage] ebuild log for ${PACKAGE} on ${HOST}"
PORTAGE_ELOG_MAILURI="root"
PORTAGE_ELOG_SYSTEM="save"
PORTAGE_FETCH_CHECKSUM_TRY_MIRRORS="5"
PORTAGE_FETCH_RESUME_MIN_SIZE="350K"
PORTAGE_GID="250"
PORTAGE_GPG_SIGNING_COMMAND="gpg --sign --digest-algo SHA256 --clearsign --yes --default-key "${PORTAGE_GPG_KEY}" --homedir "${PORTAGE_GPG_DIR}" "${FILE}""
PORTAGE_INST_GID="0"
PORTAGE_INST_UID="0"
PORTAGE_INTERNAL_CALLER="1"
PORTAGE_OVERRIDE_EPREFIX=""
PORTAGE_PYM_PATH="/usr/lib64/portage/pym"
PORTAGE_PYTHONPATH="/usr/lib64/portage/pym"
PORTAGE_REPOSITORIES="[DEFAULT]
main-repo = gentoo

[gentoo]
location = /usr/portage
masters = 
priority = -1000
sync-type = rsync
sync-uri = rsync://rsync.de.gentoo.org/gentoo-portage/

[whissi-overlay]
location = /usr/overlays/whissi-overlay
masters = gentoo
sync-type = git
sync-uri = https://github.com/Whissi/gentoo-overlay.git
"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_RSYNC_RETRIES="-1"
PORTAGE_SYNC_STALE="30"
PORTAGE_TMPDIR="/var/tmp"
PORTAGE_VERBOSE="1"
PORTAGE_WORKDIR_MODE="0700"
PORTAGE_XATTR_EXCLUDE="security.* system.nfs4_acl"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/overlays/whissi-overlay"
PORT_LOGDIR_CLEAN="find "${PORT_LOGDIR}" -type f ! -name "summary.log*" -mtime +7 -delete"
PROFILE_ONLY_VARIABLES="ARCH ELIBC IUSE_IMPLICIT KERNEL USERLAND USE_EXPAND_IMPLICIT USE_EXPAND_UNPREFIXED USE_EXPAND_VALUES_ARCH USE_EXPAND_VALUES_ELIBC USE_EXPAND_VALUES_KERNEL USE_EXPAND_VALUES_USERLAND"
PWD="/tmp"
PYTHONDONTWRITEBYTECODE="1"
PYTHON_SINGLE_TARGET="python2_7"
PYTHON_TARGETS="python2_7 python3_3"
RESUMECOMMAND="wget -c -t 3 -T 60 --passive-ftp -O "${DISTDIR}/${FILE}" "${URI}""
RESUMECOMMAND_RSYNC="rsync -avP "${URI}" "${DISTDIR}/${FILE}""
RESUMECOMMAND_SSH="bash -c "x=\${2#ssh://} ; host=\${x%%/*} ; port=\${host##*:} ; host=\${host%:*} ; [[ \${host} = \${port} ]] && port=22 ; exec rsync --rsh=\"ssh -p\${port} \${3}\" -avP \"\${host}:/\${x#*/}\" \"\$1\"" rsync "${DISTDIR}/${FILE}" "${URI}" "${PORTAGE_SSH_OPTS}""
ROOT="/"
ROOTPATH="/opt/bin:/usr/x86_64-pc-linux-gnu/gcc-bin/4.8.2"
RPMDIR="/usr/portage/rpm"
RUBY_TARGETS="ruby19 ruby20"
SHELL="/bin/bash"
SHLVL="1"
SYMLINK_LIB="yes"
SYNC="rsync://rsync.de.gentoo.org/gentoo-portage/"
SYSTEMD_LESS="FRSM --shift 5"
TERM="xterm"
UNINSTALL_IGNORE="/lib/modules/*"
USE="acl amd64 berkdb bzip2 cli cracklib crypt cxx dri fortran gdbm iconv idn ipv6 mmx modules multilib ncurses nls nptl openmp pam pcre readline session sse sse2 sse3 sse4 ssl tcpd unicode zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog cpu cpufreq disk dns ethstat network nginx ntpd ping uptime rrdcached filecount" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en de" NGINX_MODULES_HTTP="access auth_basic autoindex browser charset empty_gif fastcgi gzip limit_conn limit_req map referer rewrite" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_3" RUBY_TARGETS="ruby19 ruby20" USERLAND="GNU" VIDEO_CARDS="intel" XTABLES_ADDONS="geoip"
USER="root"
USERLAND="GNU"
USE_EXPAND="ABI_MIPS ABI_PPC ABI_S390 ABI_X86 ALSA_CARDS APACHE2_MODULES APACHE2_MPMS CALLIGRA_FEATURES CAMERAS COLLECTD_PLUGINS CROSSCOMPILE_OPTS CURL_SSL DRACUT_MODULES DVB_CARDS ELIBC ENLIGHTENMENT_MODULES FCDSL_CARDS FFTOOLS FOO2ZJS_DEVICES FRITZCAPI_CARDS GPSD_PROTOCOLS GRUB_PLATFORMS INPUT_DEVICES KERNEL LCD_DEVICES LIBREOFFICE_EXTENSIONS LINGUAS LIRC_DEVICES MONKEYD_PLUGINS NETBEANS_MODULES NGINX_MODULES_HTTP NGINX_MODULES_MAIL OFED_DRIVERS OFFICE_IMPLEMENTATION OPENMPI_FABRICS OPENMPI_OFED_FEATURES OPENMPI_RM PHP_TARGETS PYTHON_SINGLE_TARGET PYTHON_TARGETS QEMU_SOFTMMU_TARGETS QEMU_USER_TARGETS RUBY_TARGETS SANE_BACKENDS USERLAND UWSGI_PLUGINS VIDEO_CARDS VOICEMAIL_STORAGE XFCE_PLUGINS XTABLES_ADDONS"
USE_EXPAND_HIDDEN="ABI_MIPS ABI_PPC ABI_S390 CROSSCOMPILE_OPTS ELIBC KERNEL USERLAND"
USE_EXPAND_IMPLICIT="ARCH ELIBC KERNEL USERLAND"
USE_EXPAND_UNPREFIXED="ARCH"
USE_EXPAND_VALUES_ARCH="alpha amd64 amd64-fbsd amd64-linux arm arm-linux arm64 hppa hppa-hpux ia64 ia64-hpux ia64-linux m68k m68k-mint mips ppc ppc64 ppc64-linux ppc-aix ppc-macos ppc-openbsd s390 sh sparc sparc64-freebsd sparc64-solaris sparc-fbsd sparc-solaris x64-freebsd x64-macos x64-openbsd x64-solaris x86 x86-cygwin x86-fbsd x86-freebsd x86-interix x86-linux x86-macos x86-netbsd x86-openbsd x86-solaris x86-winnt"
USE_EXPAND_VALUES_ELIBC="AIX Cygwin Darwin FreeBSD glibc HPUX Interix mintlib musl NetBSD OpenBSD SunOS uclibc Winnt"
USE_EXPAND_VALUES_KERNEL="AIX Cygwin Darwin FreeBSD freemint HPUX Interix linux NetBSD OpenBSD SunOS Winnt"
USE_EXPAND_VALUES_USERLAND="BSD GNU"
USE_ORDER="env:pkg:conf:defaults:pkginternal:repo:env.d"
VIDEO_CARDS="intel"
XTABLES_ADDONS="geoip"
_="/usr/bin/emerge"
Comment 5 Thomas Deutschmann gentoo-dev Security 2014-04-22 21:12:19 UTC
Created attachment 375500 [details]
Another emerge debug log showing the iptables problem

I think this is another variant of this bug and it feels like to be related with bug 497238. At least subslotted packages in different repositories are "exposing" the problem again.

On my system I have net-firewall/iptables-1.4.21::whissi-overlay [1] installed.
The important difference between net-firewall/iptables-1.4.21::gentoo and net-firewall/iptables-1.4.21::whissi-overlay is the subslot I added to my ebuild.

net-firewall/iptables is not in the world set. iptables was pulled in by sys-apps/iproute2.

Now, net-firewall/iptables-1.4.21-r1::gentoo became available. So I also updated my ebuild and added net-firewall/iptables-1.4.21-r1::whissi-overlay [2].

When I now try to update my system, portages wants to update from net-firewall/iptables-1.4.21:0/10::whissi-overlay to net-firewall/iptables-1.4.21-r1:0/0::gentoo instead of net-firewall/iptables-1.4.21-r1:0/10::whissi-overlay:


# emerge --ignore-default-opts --pretend --verbose --update --deep world

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U  ] net-firewall/iptables-1.4.21-r1:0/0::gentoo [1.4.21:0/10::whissi-overlay] USE="ipv6 -netlink -static-libs" 0 kB
[ebuild  rR    ] sys-apps/iproute2-3.14.0  USE="berkdb iptables ipv6 -atm -minimal (-selinux)" 0 kB
[ebuild  rR    ] net-firewall/xtables-addons-2.4::whissi-overlay  USE="modules" XTABLES_ADDONS="geoip -account -chaos -condition -delude -dhcpmac -dnetmap -echo -fuzzy -gradm -iface -ipmark -ipp2p -ipv4options -length2 -logmark -lscan -pknock -psd -quota2 -sysrq -tarpit" 0 kB

Total: 3 packages (1 upgrade, 2 reinstalls), Size of downloads: 0 kB

The following packages are causing rebuilds:

  (net-firewall/iptables-1.4.21-r1:0/0::gentoo, ebuild scheduled for merge) causes rebuilds for:
    (net-firewall/xtables-addons-2.4:0/0::whissi-overlay, ebuild scheduled for merge)
    (sys-apps/iproute2-3.14.0:0/0::gentoo, ebuild scheduled for merge)


But when I only try to update net-firewall/iptables, portage will choose my ebuild like expected:


# emerge --ignore-default-opts --pretend --verbose --oneshot iptables

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U  ] net-firewall/iptables-1.4.21-r1:0/10::whissi-overlay [1.4.21:0/10::whissi-overlay] USE="ipv6 -netlink -static-libs" 0 kB

Total: 1 package (1 upgrade), Size of downloads: 0 kB


After I upgraded only iptables (emerge --oneshot iptables), which upgraded iptables to net-firewall/iptables-1.4.21-r1:0/10::whissi-overlay, portage is satisfied:

# emerge --ignore-default-opts --pretend --verbose --update --deep world

These are the packages that would be merged, in order:

Calculating dependencies... done!

Total: 0 packages, Size of downloads: 0 kB



[1] https://github.com/Whissi/gentoo-overlay/blob/master/net-firewall/iptables/iptables-1.4.21.ebuild

[2] https://github.com/Whissi/gentoo-overlay/blob/master/net-firewall/iptables/iptables-1.4.21-r1.ebuild
Comment 6 Sebastian Luther (few) 2014-04-26 19:48:05 UTC
This fixes your problem from comment 5. Let me know if it fixed the other issue too.

http://git.overlays.gentoo.org/gitweb/?p=proj/portage.git;a=commit;h=de71f70eac5f8f82d739c2d6e5da8e7680e89efe
Comment 7 Thomas Deutschmann gentoo-dev Security 2014-04-26 20:43:27 UTC
Created attachment 375804 [details]
New emerge debug log from portage with commit de71f70eac5

With this patch, 

# emerge --pretend --verbose --update --deep --with-bdeps=y --newuse world

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U  ] net-firewall/iptables-1.4.21-r1:0/0::gentoo [1.4.21:0/10::whissi-overlay] USE="ipv6 -netlink -static-libs" 0 kB
[ebuild  rR    ] sys-apps/iproute2-3.14.0  USE="berkdb iptables ipv6 -atm -minimal (-selinux)" 426 kB
[ebuild  rR    ] net-firewall/xtables-addons-2.4::whissi-overlay  USE="modules" XTABLES_ADDONS="geoip -account -chaos -condition -delude -dhcpmac -dnetmap -echo -fuzzy -gradm -iface -ipmark -ipp2p -ipv4options -length2 -logmark -lscan -pknock -psd -quota2 -sysrq -tarpit" 0 kB

Total: 4 packages (1 upgrade, 3 reinstalls), Size of downloads: 426 kB

The following packages are causing rebuilds:

  (net-firewall/iptables-1.4.21-r1:0/0::gentoo, ebuild scheduled for merge) causes rebuilds for:
    (net-firewall/xtables-addons-2.4:0/0::whissi-overlay, ebuild scheduled for merge)
    (sys-apps/iproute2-3.14.0:0/0::gentoo, ebuild scheduled for merge)


changed into


# emerge --pretend --verbose --update --deep --with-bdeps=y --newuse world

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild     U  ] net-firewall/iptables-1.4.21-r1:0/10::whissi-overlay [1.4.21:0/10::whissi-overlay] USE="ipv6 -netlink -static-libs" 0 kB
[ebuild  rR    ] net-firewall/xtables-addons-2.4::whissi-overlay  USE="modules" XTABLES_ADDONS="geoip -account -chaos -condition -delude -dhcpmac -dnetmap -echo -fuzzy -gradm -iface -ipmark -ipp2p -ipv4options -length2 -logmark -lscan -pknock -psd -quota2 -sysrq -tarpit" 0 kB
[binary  rR    ] sys-apps/iproute2-3.14.0  USE="berkdb iptables ipv6 -atm -minimal (-selinux)" 0 kB

Total: 4 packages (1 upgrade, 3 reinstalls, 1 binary), Size of downloads: 0 kB


So portage will now keep iptables from my overlay, but I don't understand why it wants to re-emerge iproute2 and xtables-addons: The subslot hasn't changed and also there's no message "The following packages are causing rebuilds:"...

I attached a new debug log from the patched portage version.


The first problem that portage still wants to rebuild rsyslog still exists.
Comment 8 Brian Dolbec gentoo-dev 2014-08-04 02:13:50 UTC
released in portage-2.2.11